#!/bin/bash

# @title Competition Website: Participating Teams
# @phase Web
# @description creates the table of participating teams for the competition website. Data is fetched from the google sheets. 

CATEGORY_STRUCTURE="benchmark-defs/category-structure.yml"
YEAR=$(yq --raw-output '.year' "$CATEGORY_STRUCTURE")
COMPETITIONNAME=$(yq --raw-output '.competition' "$CATEGORY_STRUCTURE")
TARGETSERVER=$(echo "$COMPETITIONNAME" | tr A-Z a-z)

MAIN_TRACK="Verification"
if [[ "$COMPETITIONNAME" == "Test-Comp" ]]; then
  MAIN_TRACK="Test Generation"
fi

echo "<!-- This file is generated by $0. Do not edit manually. -->";

echo "

<h2>Tools for $MAIN_TRACK</h2>

<table>
  <tr style='font-weight: bold;'>
    <td>Tool</td>
    <td>Lang.</td>
    <td>Jury member</td>
    <td>Affiliation</td>
    <td>Archive</td>
    <td>Bechmark definition</td>
    <td>Publication</td>
  </tr>
  <tr>
    <td style='font-size: 80%; font-weight: bold;'>
      Overview
    </td>
    <td style='font-size: 70%;'>
      Chair
    </td>
    <td style='font-size: 70%;'>
      <a href='https://www.sosy-lab.org/~dbeyer/'>Dirk Beyer</a>
    </td>
    <td style='font-size: 70%;'>
      LMU Munich, Germany
    </td>
    <td style='font-size: 70%';>
 
    </td>
    <td style='font-size: 70%';>

    </td>
    <td>
      <!--<a href="https://www.sosy-lab.org/research/prs/2019-04-06_SV-COMP_Dirk.pdf">talk</a>-->
    </td>
  </tr>
";

ls -1 ./fm-tools/data/*.yml \
| grep -v "schema.yml" \
| xargs --replace=ARG yq -r '["ARG", .name, .project_url] | join(";")' ARG \
| sort \
| while IFS=';' read TOOLFILE TOOLNAME TOOLURL; do
  yq -r ".competition_participations []| select(.competition == \"$COMPETITIONNAME $YEAR\" and .track == \"$MAIN_TRACK\") | [.jury_member.name, .jury_member.institution, .jury_member.country, .jury_member.url, .tool_version] | join(\";\")" "$TOOLFILE" \
  | sort -u \
  | while IFS=';' read MEMBERNAME MEMBERINST MEMBERCOUNTRY MEMBERURL TOOLVERSION; do
      echo "  <tr>";
      TOOL=$(basename ${TOOLFILE%.yml})
      TOOLFUNC=${TOOL//[2]/two}
      TOOLFUNC=${TOOLFUNC//\-/}
      TOOLLANG=$(yq -r '.input_languages | join(", ")' "$TOOLFILE")
      TOOLDOI=$(yq -r ".versions [] | select(.version == \"$TOOLVERSION\") | .doi" "$TOOLFILE")
      TOOLID=${TOOLDOI#10.5281/zenodo.}
      TOOLARCHIVE="$TOOL.zip"
      TOOLFUNC="${TOOLFUNC,,}$YEAR";
      echo "    <td style='font-size: 80%; font-weight: bold;'>";
      if [ "$TOOLURL" != "" ]; then
        echo "      <a href=\"$TOOLURL\">$TOOLNAME</a>";
      else
        echo "      $TOOLNAME";
      fi
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      echo "      $TOOLLANG";
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      if [ "$MEMBERURL" != "" ]; then
        echo "      <a href='$MEMBERURL'>$MEMBERNAME</a>";
      else
        echo "      $MEMBERNAME";
      fi
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      echo "      $MEMBERINST, $MEMBERCOUNTRY";
      echo "    </td>";
      echo "    <td style='font-size: 70%';>";
      echo "      <a href='https://doi.org/$TOOLDOI'>$TOOLID</a>";
      echo "    </td>";
      echo "    <td style='font-size: 70%';>";
      echo "      <a href='https://gitlab.com/sosy-lab/$TARGETSERVER/bench-defs/blob/${TARGETSERVER/-/}${YEAR#??}/benchmark-defs/$TOOL.xml'>$TOOL.xml</a>";
      echo "    </td>";
      echo "    <td>";
      echo "      ...";
      echo "    </td>";
      echo "  </tr>";
    done
  done
echo "
</table>
";

echo "

<h2>Tools for Validation</h2>

<table>
  <tr style='font-weight: bold;'>
    <td>Tool</td>
    <td>Lang.</td>
    <td>Format</td>
    <td>Contact</td>
    <td>Affiliation</td>
    <td>Archive</td>
    <td>Bechmark definition</td>
    <td>Publication</td>
  </tr>
";

ls -1 ./fm-tools/data/*.yml \
| grep -v "schema.yml" \
| xargs --replace=ARG yq -r '["ARG", .name, .project_url] | join(";")' ARG \
| sort \
| while IFS=';' read TOOLFILE TOOLNAME TOOLURL; do
  yq -r ".competition_participations []| select(.competition == \"$COMPETITIONNAME $YEAR\" and .track != \"$MAIN_TRACK\") | [.jury_member.name, .jury_member.institution, .jury_member.country, .jury_member.url, .tool_version] | join(\";\")" "$TOOLFILE" \
  | sort -u \
  | while IFS=';' read MEMBERNAME MEMBERINST MEMBERCOUNTRY MEMBERURL TOOLVERSION; do
      echo "  <tr>";
      TOOL=$(basename ${TOOLFILE%.yml})
      TOOLFUNC=${TOOL//[2]/two}
      TOOLFUNC=${TOOLFUNC//\-/}
      TOOLLANG=$(yq -r '.input_languages | join(", ")' "$TOOLFILE")
      TOOLTRACKS=$(yq -r "[.competition_participations [] | select(.competition == \"$COMPETITIONNAME $YEAR\" and .track != \"$MAIN_TRACK\" and .tool_version == \"$TOOLVERSION\") | .track] | join(\", \")" "$TOOLFILE" | sed -e "s/Validation of //g" -e "s/Witnesses //g")
      TOOLDOI=$(yq -r ".versions [] | select(.version == \"$TOOLVERSION\") | .doi" "$TOOLFILE")
      TOOLID=${TOOLDOI#10.5281/zenodo.}
      TOOLARCHIVE="$TOOL.zip"
      TOOLFUNC="${TOOLFUNC,,}$YEAR";
      echo "    <td style='font-size: 80%; font-weight: bold;'>";
      if [ "$TOOLURL" != "" ]; then
        echo "      <a href=\"$TOOLURL\">$TOOLNAME</a>";
      else
        echo "      $TOOLNAME";
      fi
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      echo "      $TOOLLANG";
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      echo "      $TOOLTRACKS";
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      if [ "$MEMBERURL" != "" ]; then
        echo "      <a href='$MEMBERURL'>$MEMBERNAME</a>";
      else
        echo "      $MEMBERNAME";
      fi
      echo "    </td>";
      echo "    <td style='font-size: 70%;'>";
      echo "      $MEMBERINST, $MEMBERCOUNTRY";
      echo "    </td>";
      echo "    <td style='font-size: 70%';>";
      echo "      <a href='https://doi.org/$TOOLDOI'>$TOOLID</a>";
      echo "    </td>";
      echo "    <td style='font-size: 70%';>";
      echo "      <a href='https://gitlab.com/sosy-lab/$TARGETSERVER/bench-defs/blob/${TARGETSERVER/-/}${YEAR#??}/benchmark-defs/$TOOL.xml'>$TOOL.xml</a>";
      echo "    </td>";
      echo "    <td>";
      echo "      ...";
      echo "    </td>";
      echo "  </tr>";
    done
  done
echo "
</table>
";

